// Evt_Exec.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "Serv-U.h"

#include <stdio.h>
#include <string.h>
#include <shellapi.h>

#define INIFILE         "Evt-exec.ini"                  // .ini file name

UINT ExecRet;
HINSTANCE	hInstance;

void GetCommand(char* pUserID, char* pEvent, char* pCommand);
void ParseComLine(char* pComOut,char* pComIn,RFTPEventStr* pEventStruc);

extern "C" int APIENTRY
DllMain(HINSTANCE hInstanceParam, DWORD dwReason, LPVOID lpReserved)
{
	hInstance = hInstanceParam;
    return TRUE;
}


WORD CALLBACK HandleEventHook(RFTPEventStr* pEventStruc)
{
	char ComLineIni[2*MAX_PATH];              // command line to execute
	char ComLineIni2[2*MAX_PATH];              // command line to execute
	char ComLine[2*MAX_PATH];              // command line to execute
	char ComLine2[2*MAX_PATH];              // command line to execute
	char User[40];
	char Command[40];
	char Command2[40];

	strcpy(ComLine, "");

	WORD Ret=REVNT_Proceed;    // return value, default is to allow operation
	char* pName=NULL;          // pointer to path/file name being uploaded/renamed


	// disect event
	switch (pEventStruc->Event) 
	{
		case EVNT_AbortUp:	// aborted upload
			strcpy(Command, "ABORT_UP_CMD");
			strcpy(Command2, "ABORT_UP_PARAM");
			break;
		case EVNT_EndUp:	// successful upload of file
			strcpy(Command, "END_UP_CMD");
			strcpy(Command2, "END_UP_PARAM");
			break;
		case EVNT_AbortDown:	// aborted download
			strcpy(Command, "ABORT_DOWN_CMD");
			strcpy(Command2, "ABORT_DOWN_PARAM");
			break;
		case EVNT_EndDown:	// successful download of file
			strcpy(Command, "END_DOWN_CMD");
			strcpy(Command2, "END_DOWN_PARAM");
			break;
	}

	strcpy(User, pEventStruc->User);
	GetCommand(User, Command, ComLineIni);
	if(!ComLineIni[0])		// try to get default
	{
		strcpy(User, "DEFAULT");
		GetCommand(User, Command, ComLineIni);
	}
	if(ComLineIni[0])
	{
		GetCommand(User, Command2, ComLineIni2);
		ParseComLine(ComLine, ComLineIni, pEventStruc);
		ParseComLine(ComLine2, ComLineIni2, pEventStruc);
	}

	char	Error[256];
	if(ComLine[0])
	{
//		HINSTANCE Prog = ShellExecute(NULL, NULL, ComLine, ComLine2, NULL, SW_HIDE);
		HINSTANCE Prog = ShellExecute(NULL, NULL, ComLine, ComLine2, NULL, SW_HIDE);
		if((int)Prog < 32)
		{
			switch((int)Prog)
			{
				case 0:
					strcpy(Error, "The operating system is out of memory or resources.");
					break;
				case ERROR_FILE_NOT_FOUND:
					strcpy(Error, "The specified file was not found.");
					break;
				case ERROR_PATH_NOT_FOUND:
					strcpy(Error, "The specified path was not found.");
					break;
				case ERROR_BAD_FORMAT:
					strcpy(Error, "The .exe file is invalid (non-Win32 .exe or error in .exe image).");
					break;
				case SE_ERR_ACCESSDENIED:
					strcpy(Error, "The operating system denied access to the specified file.");
					break;
				case SE_ERR_ASSOCINCOMPLETE:
					strcpy(Error, "The file name association is incomplete or invalid.");
					break;
				case SE_ERR_DDEBUSY:
					strcpy(Error, "The DDE transaction could not be completed because other DDE transactions were being processed.");
					break;
				case SE_ERR_DDEFAIL:
					strcpy(Error, "The DDE transaction failed.");
					break;
				case SE_ERR_DDETIMEOUT:
					strcpy(Error, "The DDE transaction could not be completed because the request timed out.");
					break;
				case SE_ERR_DLLNOTFOUND:
					strcpy(Error, "The specified dynamic-link library was not found.");
					break;
				case SE_ERR_NOASSOC:
					strcpy(Error, "There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable.");
					break;
				case SE_ERR_OOM:
					strcpy(Error, "There was not enough memory to complete the operation.");
					break;
				case SE_ERR_SHARE:
					strcpy(Error, "A sharing violation occurred.");
					break;
			}
		}
	}
	return(REVNT_None);
}

void ParseComLine(char* pComOut,char* pComIn,RFTPEventStr* pEventStruc)
// ******
// Parse a command line for a particular event. Turn it into a command
// that can be executed.
//
// Parameters:     pComOut = (output) resulting command line to execute
//                  pComIn = (input) command line template
//             pEventStruc = (input) event structure for current event
// ******
{
	char		ShortFileName[MAX_PATH];
	// copy input command line to output and process meta chars
	while (*pComIn!='\0') 
	{
		// scan and process meta chars
		if (*pComIn=='%') 
		{
			switch (pComIn[1]) 
			{
				case 'l':                       // Long file name
					strcpy(pComOut, pEventStruc->AuxOne);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'f':                       // file name
					GetShortPathName(pEventStruc->AuxOne,
						ShortFileName,
						sizeof(ShortFileName));
					strcpy(pComOut,ShortFileName);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'd':                       // duration
					sprintf(pComOut,"%u",pEventStruc->Duration);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'c':                       // sub event code
					sprintf(pComOut,"%u",pEventStruc->SubEvent);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'u':                       // user name
					strcpy(pComOut,pEventStruc->User);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'i':                       // client IP
					strcpy(pComOut,pEventStruc->ClientIP);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				case 'h':                       // server (home) IP
					strcpy(pComOut,pEventStruc->LocalIP);
					pComOut+=strlen(pComOut);
					pComIn+=2;
					break;
				default:                        // just copy anything we don't know
					*pComOut='%';
					pComOut++;
					pComIn++;
			}
		}
		
		// copy regular chars
		else 
		{
			*pComOut=*pComIn;
			pComOut++;
			pComIn++;
		}
	}
	
	// done, terminate output string
	*pComOut='\0';
}

void GetCommand(char* pUserID, char* pEvent, char* pCommand)
{
	char IniFile[MAX_PATH];                // full path of .ini file

	// construct full path of .ini file
	GetModuleFileName(hInstance, IniFile, MAX_PATH);
	char* pEnd=strrchr(IniFile,'\\');	// strip .dll file name
	if(pEnd) 
		pEnd[1]='\0';
	strcat(IniFile,INIFILE);              // create full path .ini name

	// get settings
	GetPrivateProfileString(pUserID, pEvent, "", pCommand, MAX_PATH, IniFile);
}

